<template>
  <div
    v-if="text || $slots.default"
    class="caption"
    :class="type"
    :data-testid="text"
  >
    <sa-icon v-if="icon" :icon="icon" size="0" />
    <span class="text">
      <!-- @slot Caption content -->
      <slot>{{ text }}</slot>
    </span>
  </div>
</template>

<script>
export default {
  name: 'SaCaption',
  props: {
    /** Caption content */
    text: {
      type: String,
      default: null
    },
    /**
     * Display style of caption
     * @values primary, success, danger
     */
    type: {
      type: String,
      default: null
    }
  },
  computed: {
    icon() {
      if (this.type === 'success') {
        return 'check-circle'
      }
      if (this.type === 'danger') {
        return 'alert-triangle'
      }
      return null
    }
  }
}
</script>

<style lang="scss" scoped>
.caption {
  font-size: font-size(0);
  color: color(grey);
  * + * {
    margin-left: spacing(0);
  }
}
.success {
  color: color(success-dark);
}
.danger {
  color: color(danger-dark);
}
</style>
